<?php
namespace ReynaertBe\DIP;

class JSONError {
    private $error = false; //think positive
    private $major = '';
    private $message = '';

    public function hasError() {
        return $this->error;
    }

    public function setError($val){
        if (is_string($val)) {
            $val = ($val == 'true');
        }
        $this->error = $val;
        return $this;
    }

    public function getMajor(){
        return $this->major;
    }

    public function setMajor($val){
        $this->major = $val;
        return $this;
    }

    public function getMessage(){
        return $this->message;
    }

    public function setMessage($val){
        $this->message = $val;
        return $this;
    }

    public function __construct($message='', $error=false, $major=null) {
        $this->error = $error;
        $this->major = $major;
        $this->message = $message;
        return $this;
    }

    public function __toString() {
        return json_encode( $this->asArray() );
    }

    public function asArray() {
        $a = [];
        if ($this->error) $a['error']=true;
        if (!is_null($this->major) && $this->major <> '') $a['major'] = $this->major;
        $a['message'] = $this->message;
        return $a;
    }
}